#----------------------------------------------------------------------------
#    .
#       
#   Suzi patch     cp1251.
# : .chanset #chan +soccer
# : !
# :  (a.k.a amatus) @ SolarNet
# Url: http://www.moscow.solarnet.ru
#----------------------------------------------------------------------------

package require Tcl 8.4
package require http 2.5

namespace eval soccer {
	
    # timer 	-      .
    # prefix 	-     .
    # msg 		-       (1 - , 0 - ).
    # timeout 	-  http-  .
    # output 	-   ,     ($chan  $nick).
    # bind 		- ,    .
    # url 		- ,    .
    
	array set conf {
		timer	{60}
		prefix	{!}
		msg		{1}
		output	{$chan}
		timeout {10}
		url		{http://www.sports.ru/tags/1363803.html?type=table}
		binds 	{
			"football"
			"soccer"
			""
		}
	}
	
	#   (  soccer)
    variable flag [namespace tail [namespace current]]
	
#----------------------------------------------------------------------------
#     ,   ,  .
#----------------------------------------------------------------------------    

	foreach bind [binds "[namespace current]::*"] {catch {unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]}}
	
	foreach bind $conf(binds) {
		bind pub -|- ${conf(prefix)}${bind} [namespace current]::pub
		if {$conf(msg)} {
			bind msg -|- ${conf(prefix)}${bind} [namespace current]::msg
		}
	}
	
	variable author  { (a.k.a amatus) @ SolarNet}
	variable date    {13.02.2011}
	variable version {v1.0}
	
	setudef flag $flag
	
}

proc ::soccer::pub {nick host hand chan text} {
    variable flag;
    if {[channel get $chan $flag]} {
        main $nick $host $hand $chan $text
        return 0
    } else {
        return 0
    }
}

proc ::soccer::msg {nick host hand text} {
    variable conf;
    if {$conf(msg) && [onchan $nick]} {
        main $nick $host $hand $nick $text
        return 0
    } else {
        return 0
    }
}

proc ::soccer::main {nick host hand chan text} {
	variable conf; variable timers; global lastbind;

    if {[info exists timers($host)]} {
		
        set timewait [expr {$timers($host) + $conf(timer) - [unixtime]}]
        
        if {$timewait > 0} {
			
            putserv "NOTICE $nick : $lastbind    $timewait ."
            
            return 0
            
        } 
        
	}
		
	set timers($host) [unixtime]
        
    foreach {id} [array names timers] {if {[expr {$timers($id) + $conf(timer) - [unixtime]}] < 0} {array unset timers $id}}
	
    ::http::config -urlencoding utf-8 -accept "text/html" -useragent "Mozilla/5.0 (X11; U; Linux x86_64; ru; rv:1.9.0.10) Gecko/2009042523 Ubuntu/9.04 (jaunty) Firefox/3.0.10"
	
	if {[catch {set token [::http::geturl $conf(url) -timeout [expr {$conf(timeout) * 1000}]]} error]} {return $error}
	
	regsub -all -- {[\n]+} [::http::data $token] {} data
	
	regexp -nocase -- {<tbody>(.+?)</tbody>} $data -> table
	
	putserv "PRIVMSG [subst $conf(output)] : |  |  |  |  |  |  |  | "
	
	set count 0
	
	foreach i $table {
		
		if {[regexp -nocase -- {href=.+>(.+?)</a>.+<td>(.+)</td><td>(.+)</td><td>(.+)</td><td>(.+)</td><td>(.+)</td><td>(.+)</td><td>(.+)</td></tr>} $i -> row(name) row(1) row(2) row(3) row(4) row(5) row(6) row(7)]} {
			
			incr count
			
			putserv "PRIVMSG [subst $conf(output)] :$count | $row(name) | $row(1) | $row(2) | $row(3) | $row(4) | $row(5) | $row(6) | $row(7)"
			
		}
		
	}
	
	::http::cleanup $token
	
	return 0
	
}

putlog "::soccer :: $::soccer::version :: $::soccer::date :: by $::soccer::author :: loaded..."
